%def_disable static
%remove_optflags -O2
%add_optflags -Os

Name: librtorrent
Version: 0.11.4
Release: alt1

Summary: libTorrent is a BitTorrent library written in C++ for *nix
Group: System/Libraries
License: GPL
Url: http://libtorrent.rakshasa.no/
Packager: Alexey Morsov <swi@altlinux.ru>

%define full_version %version
Source0: %name-%full_version.tar.bz2

BuildRequires: gcc-c++ libsigc++2.0-devel libssl-devel libstdc++-devel pkgconfig

%description
libTorrent is designed to avoid redundant copying and storing of data that
other clients and libraries suffer from. libTorrent features:

* The client has full control over the polling of sockets.
* Sigc++ signals makes it easy for the client to react to events.
* Fast resume which checks the file modification time.
* Direct reading and writing from network to mmap'ed files.
* File hash check uses the same thread; client can control the rate;
  non-blocking and preload to memory with the mincore and madvise.
* File handler: fine-grained use of file read/write permissions, allows seeding
  of read-only files; allows torrents with unlimited number of files; opens
  closed files when mapping chunks to memory, with graceful error handling;
  support for files larger than 2 GB; different download priorities for files
  in the torrent.
* Multi-tracker support.
* No dependency on any specific HTTP library, the client implements a wrapper
  class.
* Dynamic request pipe size.
* Upload and download throttle.
* And much more...

%package devel
Summary: Development libraries and header files for libTorrent
Group: Development/C
Requires: %name = %version-%release

%description devel
The libtorrent-devel package contains libraries and header files needed
to develop applications using libTorrent.

%package devel-static
Summary: Development static library for libTorrent
Group: Development/C
Requires: %name-devel = %version-%release

%description devel-static
This package contains static version of libTorrent library. Install
libtorrent-devel-static if you want to develop applications statically linked
with libTorrent.

%prep
%setup -q -n %name-%full_version
%__mv -f COPYING COPYING.orig
%__ln_s $(relative %_licensedir/GPL-2 %_docdir/%name/COPYING) COPYING
# damn fork goes here
# prepare to use it like rtorrent (not torrent)
find . -type f -name \* -print0 | xargs -r0 subst 's|libtorrent|librtorrent|g'
find . -type f -name \* -print0 | xargs -r0 subst 's|LIBTORRENT|LIBRTORRENT|g'
find . -type f -name \* -print0 | xargs -r0 subst 's|-ltorrent|-lrtorrent|g'
find ./src/torrent -type f -name Makefile.am -print0 | xargs -r0 subst 's|/torrent|/rtorrent|g'
rename libtorrent librtorrent libtorrent.pc.in

%build
%__autoreconf
%configure %{subst_enable static}
%make_build

%install
%make_install DESTDIR=%buildroot install

# remove non-packaged files
%__rm -f %buildroot%_libdir/*.la
%if_disabled static
%__rm -f %buildroot%_libdir/*.a
%endif
# patch names in .h files
find %buildroot%_includedir/rtorrent -type f -name \*.h -print0 | xargs -r0 subst 's|<torrent/|<rtorrent/|g'

%post -p %post_ldconfig
%postun -p %postun_ldconfig

%files
%doc AUTHORS ChangeLog NEWS README
%doc --no-dereference COPYING

%_libdir/*.so.*

%files devel
%_includedir/*
%_libdir/*.so
%_libdir/pkgconfig/*

%if_enabled static
%files devel-static
%_libdir/*.a
%endif

%changelog
* Mon Apr 09 2007 Alexey Morsov <swi@altlinux.ru> 0.11.4-alt1
- new version (new features, encryption support, bug fixes)

* Mon Nov 13 2006 Andrei Bulava <abulava@altlinux.ru> 0.10.4-alt1
- 0.10.4
- built with "-Os" instead of "-O2" as suggested by upstream

* Mon Sep 11 2006 Andrei Bulava <abulava@altlinux.ru> 0.9.3-alt1
- 0.9.3

* Thu May 04 2006 Andrei Bulava <abulava@altlinux.ru> 0.8.5-alt1
- 0.8.5
- referenced everywhere in spec as libTorrent instead of LibTorrent
  though upstream mixes the above names here and where :)
- dropped gcc_warnings_comparison and gcc_warnings patches (fixed
  upstream)
- replaced COPYING with a symlink to the system-wide GPL-2 text

* Fri Nov 18 2005 Andrei Bulava <abulava@altlinux.ru> 0.7.6-alt1
- 0.7.6

* Fri Oct 28 2005 Andrei Bulava <abulava@altlinux.ru> 0.7.5-alt1
- 0.7.5
- minor spec fixes regarding build process
- applied patches to fix obvious GCC warnings

* Mon Sep 26 2005 Andrei Bulava <abulava@altlinux.ru> 0.7.0-alt1
- 0.7.0-1
- updated BuildRequires
- minor fix to handle versioning of stable releases

* Mon Jun 13 2005 Andrei Bulava <abulava@altlinux.ru> 0.6.4-alt1
- initial build for ALT Linux
